<?php
/**
 * ----------------------------------------------
 * Advanced Guestbook 2.4.4 (PHP/MySQL)
 * Copyright (c) Chi Kien Uong
 * URL: http://www.proxy2.de
 * ----------------------------------------------
 */

class gbook_sql {

    var $link;
    var $result;
    var $record;
    var $db = array();
    var $port;

    function __construct() {
        global $GB_DB;
        $this->db = &$GB_DB;
        if (strpos($this->db['host'], ':') !== FALSE) {
            list($host,$port) = explode(":",$this->db['host']);
            $this->port = $port;
        } else {
            $this->port = 3306;
        }
    }

    function connect() {
        $this->link = mysqli_connect($this->db['host'], $this->db['user'], $this->db['pass'], $this->db['dbName'], $this->port);
        if (!$this->link) {            
            $this->sql_error("Connection Error");
            return false;
        }
        $this->link->query("SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");
        return $this->link;
    }

    function query($query_string) {
        $this->result = $this->link->query($query_string);
        if (!$this->result) {
            $this->sql_error("Query Error");
        }
        return $this->result;
    }

    function fetch_array($stmt) {
		if ($stmt) {
			$this->record = $stmt->fetch_assoc();
		}
        return $this->record;
    }

    function num_rows($stmt) {
        if ($stmt) {
			return $stmt->num_rows;
		}
		return 0;
    }

    function num_fields($stmt) {
        if ($stmt) {
			return $stmt->field_count;
		}
		return 0;
    }

    function free_result($stmt) {
		if ($stmt) {
			return $stmt->free();
		}
    }

    function affected_rows() {
		if ($this->link) {
			return $this->link->affected_rows;
		}
		return 0;
    }

    function close_db() {
        if ($this->link) {
            return $this->link->close();
        } else {
            return false;
        }
    }

    function sql_error($message) {
        global $TEC_MAIL;
        $description = mysqli_connect_error();
        $number = mysqli_connect_errno();
        $error ="MySQL Error : $message\n";
        $error.="Error Number: $number $description\n";
        $error.="Date        : ".date("D, F j, Y H:i:s")."\n";
        $error.="IP          : ".getenv("REMOTE_ADDR")."\n";
        $error.="Browser     : ".getenv("HTTP_USER_AGENT")."\n";
        $error.="Referer     : ".getenv("HTTP_REFERER")."\n";
        $error.="PHP Version : ".PHP_VERSION."\n";
        $error.="OS          : ".PHP_OS."\n";
        $error.="Server      : ".getenv("SERVER_SOFTWARE")."\n";
        $error.="Server Name : ".getenv("SERVER_NAME")."\n";
        echo "<b><font size=4 face=Arial>$message</font></b><hr>";
        echo "<pre>$error</pre>";
        if (!empty($TEC_MAIL)) {
            $headers = "From: $TEC_MAIL\r\nX-Mailer: Advanced Guestbook 2";
            // @mail("$TEC_MAIL","Guestbook - Error","$error","$headers");
        }
        exit();
    }

}
